# Overview

This charm installs and loads the IO Visor kernel module on a node.

Once deployed, the charm installs the necessary IO Visor kernel module required by the PLUMgrid plugin. IO Visor is a programmable data plane component that is used to implement distributed network functions. It also sets the MTU of the node to 1580 bytes.

# Usage

Step by step instructions on using the charm:

    juju deploy neutron-api
    juju deploy neutron-plumgrid-plugin
    juju deploy neutron-iovisor
    juju add-relation neutron-api neutron-plumgrid-plugin
    juju add-relation neutron-plumgrid-plugin neutron-iovisor

This charm only configures IO visor on the node. To use is with Neutron you can deploy plumgrid-director, plumgrid-edge or plumgrid-gateway charms on the same node. 

# Known Limitations and Issues

This is an early access version of the IO Visor charm and it is not meant for production deployments. This charm should not be deployed to an lxc as it installs a kernel module.

# Configuration

Provide the source repo path for PLUMgrid Debs in 'install_sources' and the corresponding keys in 'install_keys'

Example Config

    neutron-iovisor:
        install_sources: 'ppa:plumgrid-team/stable'
        install_keys: 'null'

Provide the source repo path for PLUMgrid Debs in 'install_sources' and the corresponding keys in 'install_keys'

# Contact Information

Bilal Baqar <bbaqar@plumgrid.com>
Bilal Ahmad <bilal@plumgrid.com>
