from charmhelpers.contrib.openstack.neutron import neutron_plugin_attribute
from charmhelpers.core.hookenv import log
from charmhelpers.contrib.storage.linux.ceph import modprobe
from charmhelpers.core.host import set_nic_mtu
from subprocess import (
    check_call,
    check_output,
)


def load_iovisor():
    #TODO: Check if openvswitch is loaded from lsmod | grep open and then
    #rmmod if neccessary. Create a check_iovisor function
    modprobe('iovisor')


def remove_iovisor():
    check_call(['rmmod', 'iovisor'])


def determine_packages():
    return neutron_plugin_attribute('plumgrid', 'packages', 'neutron')


def ensure_mtu():
    log("Changing MTU of Juju-br0 and all attached interfaces")
    cmd = check_output(["brctl", "show", "juju-br0"])
    interfaces = ['eth0']
    words = cmd.split()
    for word in words:
        if 'veth' in word:
            interfaces.append(word)
            set_nic_mtu(word, '1580')
    set_nic_mtu('eth0', '1580')
    set_nic_mtu('juju-br0', '1580')
