from mock import patch, call

from test_utils import CharmTestCase

with patch('charmhelpers.core.hookenv.config') as config:
    config.return_value = 'neutron'
import neutron_iovisor_hooks as hooks

TO_PATCH = [
    'apt_update',
    'apt_install',
    'apt_purge',
    'configure_sources',
    'determine_packages',
    'log',
    'load_iovisor',
    'remove_iovisor',
    'ensure_mtu',
]


class NeutronIovisorHooksTests(CharmTestCase):

    def setUp(self):
        super(NeutronIovisorHooksTests, self).setUp(hooks, TO_PATCH)

        hooks.hooks._config_save = False

    def _call_hook(self, hookname):
        hooks.hooks.execute([
            'hooks/{}'.format(hookname)])

    def test_install_hook(self):
        _pkgs = ['foo', 'bar']
        self.determine_packages.return_value = [_pkgs]
        self._call_hook('install')
        self.configure_sources.assert_called_with()
        self.apt_update.assert_called_with()
        self.apt_install.assert_has_calls([
            call(_pkgs, fatal=True,
                 options=['--force-yes',
                          '--option=Dpkg::Options::=--force-confold']),
        ])
        self.load_iovisor.assert_called_with()
        self.ensure_mtu.asser_called_with()
